﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace tediadaq01_dotnet
{
    public class TediaDaq01
    {
        const string DLL_NAME = "tedia_daq01.dll";
        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Close_Driver(UInt32 handle);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Config_Ability_Generate_IRQ(UInt32 handle, UInt32 global_ability, UInt32 irqcfgreg);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Config_Acquisition(UInt32 handle, UInt32 parametr0,
            UInt32 parametr1, UInt32 index_of_channel,
            UInt32 number_of_channels);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Config_DIO(UInt32 handle, UInt32 parametr0, UInt32 parametr1, UInt32 index_of_dio);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Config_Generating(UInt32 handle, UInt32 parametr0, UInt32 parametr1, UInt32 index_of_channel, UInt32 number_of_channels);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Config_Generating_Mode(UInt32 handle, UInt32 p_mode, UInt32 d_mode, UInt32 wait_for_acquisition);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Config_IRQTimer(UInt32 handle, ref double frequency, ref double period);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Config_ScanCounter(UInt32 handle, UInt32 parametr0,
            UInt32 index_of_scan_counter);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Config_Timing_Acquisition(UInt32 handle,
            ref double frequnecy, ref double period);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Config_Timing_Generating(UInt32 handle, ref double frequency, ref double period);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Driver_Version(ref UInt32 version_hi, ref UInt32 version_low, UInt32 select);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Buffer_Data(UInt32 handle, UInt32[] buffer, UInt32 size_buffer, ref UInt32 recorded_row);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Buffer_Status(UInt32 Handle, ref UInt32 count_new_row);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Counter(UInt32 Handle, UInt32 index_of_counter,
            UInt32[] buffer, UInt32 number_of_counters, UInt32 source);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Counter_Status(UInt32 handle, UInt32 index_of_counter, UInt32 parameter, ref UInt32 value);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_DeviceName(StringBuilder name,
            UInt32 index_of_device);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_DeviceType(StringBuilder name, UInt32 index_of_type);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_DI(UInt32 handle, UInt32 index_of_input,
            UInt32[] buffer, UInt32 number_of_inputs);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_ErrorMessage(UInt32 Handle,
            StringBuilder name_of_function, StringBuilder name_of_error);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Generating_Status(UInt32 handle, UInt32 name_of_parameter, ref UInt32 result);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Info_DeviceName(StringBuilder name,
            UInt32 parameter, ref Double numerical_result,
            StringBuilder alphanumeric_result, ref UInt32 type_of_result);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Info_DeviceType(StringBuilder name_of_type, UInt32 parameter, ref double numerical_result, StringBuilder alphanumeric_result, ref UInt32 type_of_result);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Number_Of_Devices(ref UInt32 number_of_devices);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Number_Of_Types(ref UInt32 number_of_types);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_Parameters(UInt32 handle, UInt32 parameter, ref double numerical_result, StringBuilder alphanumeric_result, ref UInt32 result_type);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_SingleAcquisition(UInt32 handle,
            UInt32[] buffer,
            UInt32 size_of_buffer);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Get_State_Buffer_Data_Input(UInt32 handle, ref UInt32 state);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Init_Driver(ref UInt32 handle, StringBuilder name);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Load_Counter(UInt32 Handle, UInt32 source);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Load_Counter_Status(UInt32 handle);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Read_DevEE(UInt32 handle, UInt32 index_of_page, ref UInt32 buffer);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Save_Counter(UInt32 Handle);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Save_Counter_Parameters(UInt32 handle);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Save_StartStop_Counter(UInt32 handle);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Set_AO(UInt32 handle, UInt32 index_of_output, UInt32[] buffer, UInt32 number_of_outputs);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Set_Buffer_Data(UInt32 handle, UInt32[] buffer, UInt32 size_buffer, ref UInt32 number_of_set);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Set_Counter(UInt32 Handle, UInt32 index_of_counter,
            UInt32[] buffer, UInt32 number_of_counters);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Set_Counter_Parameters(UInt32 handle, UInt32 index_of_counter, UInt32 parameter, UInt32 value);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Set_DO(UInt32 handle, UInt32 index_of_output,
             UInt32[] buffer, UInt32 number_of_outputs);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Set_Parameters(UInt32 handle, UInt32 parameter, double numerical_input, StringBuilder alphanumeric_input, UInt32 type_of_input, UInt32 permanency);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Size_DevEE(UInt32 handle, ref UInt32 size);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Start_Acquisition(UInt32 handle, UInt32 p_mode);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Start_Counter(UInt32 Handle, UInt32 index_of_counter);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Start_Generating(UInt32 handle);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Stop_Acquisition(UInt32 handle);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Stop_Counter(UInt32 handle, UInt32 index_of_counter);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Stop_Generating(UInt32 handle);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Visual_Administrate();

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Visual_Parameters(UInt32 handle);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Wait_For_IRQ(UInt32 handle, UInt32 timeout, ref UInt32 status, ref UInt32 result_IRQ);

        [DllImport(DLL_NAME)]
        public static extern
        UInt32 Td_Write_DevEE(UInt32 handle, UInt32 index_of_page, UInt32[] buffer);
    }
}
